BZOJ4671 异或图 斯特林反演+线性基
题目传送门
https://lydsy.com/JudgeOnline/problem.php?id=4671
题解
半年前刚学计数的时候对这道题怀着深深的景仰,现在终于可以来做这道题了。
类似于一般的容斥和反演题,我们发现整个图是联通的图非常不好求。于是我们转化为整个图钦定了有 \(i\) 个块必须不连通,其余任意的方案数。
然后考虑这个怎么求,我们可以暴力枚举一下把这些数分成很多组,显然方案数就时 \(B_n\)(贝尔数,就是 \(\sum\limits_{i=0}^n \begin{Bmatrix}n\\i\end{Bmatrix}\) 的和,在 \(n \leq 10\) 的时候都不超过十万级别)。
然后就是相当于有一些边不能存在,其余的别可以任意存在。考虑用一个线性基来维护。由于边数不超过 \(\frac{n(n-1)}2\),所以可以用 ll 表示。然后问题转化为一个数有多少个子集存在于线性基中。
但是一个数有多少个子集存在于线性基中不太好维护,经过某位同学的提示,可以想到把那些可以任意为 \(0/1\) 的位扔掉,只记录只能为 \(0\) 的位,把这些位扔进线性基。最后只需要用线性基求出有多少种方案使得异或和为 \(0\) 就可以了。
以下是代码,时间复杂度为 \(O(B_nn^2m)\)。
#include<bits/stdc++.h>
#define fec(i, x, y) (int i = head[x], y = g[i].to; i; i = g[i].ne, y = g[i].to)
#define dbg(...) fprintf(stderr, __VA_ARGS__)
#define File(x) freopen(#x".in", "r", stdin), freopen(#x".out", "w", stdout)
#define fi first
#define se second
#define pb push_back
template<typename A, typename B> inline char smax(A &a, const B &b) {return a < b ? a = b , 1 : 0;}
template<typename A, typename B> inline char smin(A &a, const B &b) {return b < a ? a = b , 1 : 0;}
typedef long long ll; typedef unsigned long long ull; typedef std::pair<int, int> pii;
template<typename I>
inline void read(I &x) {
int f = 0, c;
while (!isdigit(c = getchar())) c == '-' ? f = 1 : 0;
x = c & 15;
while (isdigit(c = getchar())) x = (x << 1) + (x << 3) + (c & 15);
f ? x = -x : 0;
}
template<typename I>
inline void read2(char *s, I &x) {
int f = 0, c;
while (!isdigit(c = *s++)) c == '-' ? f = 1 : 0;
x = c & 15;
while (isdigit(c = *s++)) x = (x << 1) + (c & 15);
f ? x = -x : 0;
}
const int N = 45 + 7;
const int M = 60 + 7;
int n, m, sn, ssn;
int a[N], bl[N], ss[N];
ll b[M], f[N], S[N][N];
pii dy[N];
char s[N], p[N];
struct XXJ {
ll a[N];
inline void cls() { memset(a, 0, sizeof(a)); }
inline bool ins(ll x) {
for (int i = ssn - 1; ~i; --i)
if ((x >> i) & 1) {
if (a[i]) x ^= a[i];
else return a[i] = x, 1;
}
return 0;
}
inline int count() {
int cnt = 0;
for (int i = ssn - 1; ~i; --i) if (a[i]) ++cnt;
return cnt;
}
} gg;
inline void calc(int y) {
ss[0] = 0;
for (int i = 0; i < sn; ++i)
if (bl[dy[i].fi] != bl[dy[i].se]) ss[++ss[0]] = i;
ssn = ss[0], gg.cls();
for (int i = 1; i <= m; ++i) {
ll c = 0;
for (int j = ss[0]; j; --j) c = c << 1 | ((b[i] >> ss[j]) & 1);
gg.ins(c);
}
f[y] += 1ll << (m - gg.count());
}
inline void dfs(int x, int y) {
if (x == n + 1) return calc(y);
for (int i = 1; i <= y + 1; ++i) bl[x] = i, dfs(x + 1, std::max(y, i));
}
inline void work() {
dfs(1, 0);
ll ans = 0;
S[0][0] = 1;
for (int i = 1; i <= n; ++i)
for (int j = 1; j <= i; ++j) S[i][j] = S[i - 1][j - 1] + (i - 1) * S[i - 1][j];
for (int i = 1; i <= n; ++i)
if ((i - 1) & 1) ans -= S[i][1] * f[i];
else ans += S[i][1] * f[i];
printf("%lld\n", ans);
}
inline void init() {
read(m);
for (int i = 1; i <= m; ++i) {
scanf("%s", s + 1);
int nn = strlen(s + 1);
std::reverse(s + 1, s + nn + 1);
n = (1 + (int)sqrt(1 + 8 * nn)) >> 1;
read2(s + 1, b[i]);
}
sn = 0;
for (int i = 1; i <= n; ++i)
for (int j = i + 1; j <= n; ++j) dy[sn++] = pii(i, j);
}
int main() {
#ifdef hzhkk
freopen("hkk.in", "r", stdin);
#endif
init();
work();
fclose(stdin), fclose(stdout);
return 0;
}
BZOJ4671 异或图 斯特林反演+线性基的更多相关文章
- bzoj4671 异或图(斯特林反演,线性基)
bzoj4671 异或图(斯特林反演,线性基) 祭奠天国的bzoj. 题解时间 首先考虑类似于容斥的东西. 设 $ f_{ i } $ 为至少有 $ i $ 个连通块的方案数, $ g_{ i } $ ...
- bzoj4671: 异或图——斯特林反演
[BZOJ4671]异或图 - xjr01 - 博客园 考虑先算一些限制少的情况 gi表示把n个点的图,划分成i个连通块的方案数 连通块之间不连通很好处理(怎么处理看下边),但是内部必须连通,就很难办 ...
- BZOJ4671 异或图(容斥+线性基)
题意 定义两个结点数相同的图 \(G_1\) 与图 \(G_2\) 的异或为一个新的图 \(G\) ,其中如果 \((u, v)\) 在 \(G_1\) 与 \(G_2\) 中的出现次数之和为 \(1 ...
- 【bzoj4671】异或图(容斥+斯特林反演+线性基)
传送门 题意: 给出\(s,s\leq 60\)张图,每张图都有\(n,n\leq 10\)个点. 现在问有多少个图的子集,满足这些图的边"异或"起来后,这张图为连通图. 思路: ...
- bzoj 4671 异或图——容斥+斯特林反演+线性基
题目:https://www.lydsy.com/JudgeOnline/problem.php?id=4671 考虑计算不是连通图的方案,乘上容斥系数来进行容斥. 可以枚举子集划分(复杂度是O(Be ...
- bzoj 4671 异或图 —— 容斥+斯特林反演+线性基
题目:https://www.lydsy.com/JudgeOnline/problem.php?id=4671 首先,考虑容斥,就是设 \( t[i] \) 表示至少有 \( i \) 个连通块的方 ...
- bzoj4671: 异或图
bzoj4671: 异或图 Description 定义两个结点数相同的图 G1 与图 G2 的异或为一个新的图 G, 其中如果 (u, v) 在 G1 与 G2 中的出现次数之和为 1, 那么边 ( ...
- BZOJ4671异或图
题目描述 定义两个结点数相同的图 G1 与图 G2 的异或为一个新的图 G, 其中如果 (u, v) 在 G1 与 G2 中的出现次数之和为 1, 那么边 (u, v) 在 G 中, 否则这条边不在 ...
- P5169 xtq的异或和(FWT+线性基)
传送门 我咋感觉我学啥都是白学-- 首先可以参考一下这一题,从中我们可以知道只要知道两点间任意一条路径以及整个图里所有环的线性基,就可以得知这两个点之间的所有路径的异或和 然而我好像并不会求线性基能张 ...
随机推荐
- socket函数库简单封装
#pragma once #ifndef WINSOCK_H #include<WinSock2.h> #pragma comment(lib,"ws2_32.lib" ...
- 数据导入导出mysql版本不同导致的问题
5.6.16-log导出.5.5.47-log导入 `addtime` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '记录生产时间', 需要修改为: `add ...
- mysql 1067 - Invalid default value for 'addtime'错误处理
错误描述 TABLE `bota_payment_closing` ( `id` int(11) NOT NULL AUTO_INCREMENT, `monthly` varchar(8) NOT N ...
- Android 中的 Matrix
Matrix 是 Android SDK 提供的一个矩阵类,它代表一个 3 X 3 的矩阵 Matrix主要可以对图像做4种基本变换 Translate 平移变换 Rotate 旋转变换 Scale ...
- vue 3.0 vue-cli项目搭建要点
一.使用vue-cli搭建项目(可使用vue ui图形化界面搭建项目,配置dist时,将名称设为项目名称) 二.项目搭建后 1.配置vue.config.js // 翻阅文档https://cli.v ...
- NOIp 图论算法专题总结 (1):最短路、最小生成树、最近公共祖先
系列索引: NOIp 图论算法专题总结 (1) NOIp 图论算法专题总结 (2) NOIp 图论算法专题总结 (3) 最短路 Floyd 基本思路:枚举所有点与点的中点,如果从中点走最短,更新两点间 ...
- SHADER 用 step替代 if-else
今天聊起这个问题,百度发现了这个优化方式: https://blog.csdn.net/liu_if_else/article/details/77455639
- 16/8/23_CSS自动换行
转载:http://blog.csdn.net/ye987987/article/details/8011875 自动换行问题,正常字符的换行是比较合理的,而连续的数字和英文字符常常将容器撑大,挺 ...
- JSP表单提交 与 接受显示
Demo01.jsp 提交表单输入的信息至 Demo02.jsp方法一 1 <%@ page language="java" contentType="text/h ...
- 使EasyUI的window、panel、dialog 不被拖出页面
function easyuiPanelOnMove(left, top) { var l = left; var t = top; if (l < 1) { l = 1; } ...